Index: font-lock.el
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/lisp/font-lock.el,v
retrieving revision 1.29
diff -u -r1.29 font-lock.el
--- lisp/font-lock.el	2005/01/26 04:18:15	1.29
+++ lisp/font-lock.el	2005/02/10 02:41:21
@@ -2823,6 +4245,212 @@
 	     (goto-char (match-end 2)))   ; non-nil
 	 (error t))))))
 
+
+;;; FSF version of Java (21.2):
+
+; ;;; Java.
+
+; (defconst java-font-lock-keywords-1 nil
+;   "Subdued level highlighting for Java mode.")
+
+; (defconst java-font-lock-keywords-2 nil
+;   "Medium level highlighting for Java mode.
+; See also `java-font-lock-extra-types'.")
+
+; (defconst java-font-lock-keywords-3 nil
+;   "Gaudy level highlighting for Java mode.
+; See also `java-font-lock-extra-types'.")
+
+; ;; Regexps written with help from Fred White <fwhite@bbn.com>,
+; ;; Anders Lindgren <andersl@andersl.com> and Carl Manning <caroma@ai.mit.edu>.
+; (let* ((java-keywords
+; 	(eval-when-compile
+; 	  (regexp-opt
+; 	   '("catch" "do" "else" "super" "this" "finally" "for" "if"
+; 	     ;; Anders Lindgren <andersl@andersl.com> says these have gone.
+; 	     ;; "cast" "byvalue" "future" "generic" "operator" "var"
+; 	     ;; "inner" "outer" "rest"
+; 	     "implements" "extends" "throws" "instanceof" "new"
+; 	     "interface" "return" "switch" "throw" "try" "while"))))
+;        ;;
+;        ;; Classes immediately followed by an object name.
+;        (java-type-names
+; 	`(mapconcat 'identity
+; 	  (cons
+; 	   ,(eval-when-compile
+; 	      (regexp-opt '("boolean" "char" "byte" "short" "int" "long"
+; 			    "float" "double" "void")))
+; 	   java-font-lock-extra-types)
+; 	  "\\|"))
+;        (java-type-names-depth `(regexp-opt-depth ,java-type-names))
+;        ;;
+;        ;; These are eventually followed by an object name.
+;        (java-type-specs
+; 	(eval-when-compile
+; 	  (regexp-opt
+; 	   '("abstract" "const" "final" "synchronized" "transient" "static"
+; 	     ;; Anders Lindgren <andersl@andersl.com> says this has gone.
+; 	     ;; "threadsafe"
+; 	     "volatile" "public" "private" "protected" "native"
+; 	     ;; Carl Manning <caroma@ai.mit.edu> says this is new.
+; 	     "strictfp"))))
+;        )
+;  (setq java-font-lock-keywords-1
+;   (list
+;    ;;
+;    ;; Fontify class names.
+;    '("\\<\\(class\\)\\>[ \t]*\\(\\sw+\\)?"
+;      (1 font-lock-keyword-face) (2 font-lock-type-face nil t))
+;    ;;
+;    ;; Fontify package names in import directives.
+;    '("\\<\\(import\\|package\\)\\>[ \t]*\\(\\sw+\\)?"
+;      (1 font-lock-keyword-face)
+;      (2 font-lock-constant-face nil t)
+;      ("\\=\\.\\(\\*\\|\\sw+\\)" nil nil
+;       (1 font-lock-constant-face nil t)))
+;    ))
+
+;  (setq java-font-lock-keywords-2
+;   (append java-font-lock-keywords-1
+;    (list
+;     ;;
+;     ;; Fontify class names.
+;     `(eval .
+;       (cons (concat "\\<\\(" ,java-type-names "\\)\\>[^.]")
+; 	    '(1 font-lock-type-face)))
+;     ;;
+;     ;; Fontify all builtin keywords (except below).
+;     (concat "\\<\\(" java-keywords "\\|" java-type-specs "\\)\\>")
+;     ;;
+;     ;; Fontify keywords and targets, and case default/goto tags.
+;     (list "\\<\\(break\\|case\\|continue\\|goto\\)\\>[ \t]*\\(-?\\sw+\\)?"
+; 	  '(1 font-lock-keyword-face) '(2 font-lock-constant-face nil t))
+;     ;; This must come after the one for keywords and targets.
+;     '(":" ("^[ \t]*\\(\\sw+\\)[ \t]*:[ \t]*$"
+; 	   (beginning-of-line) (end-of-line)
+; 	   (1 font-lock-constant-face)))
+;     ;;
+;     ;; Fontify all constants.
+;     '("\\<\\(false\\|null\\|true\\)\\>" . font-lock-constant-face)
+;     ;;
+;     ;; Javadoc tags within comments.
+;     (list
+;      (concat "@\\("
+; 	     "author\\|deprecated\\|exception"
+; 	     "\\|link\\|return\\|see\\|serial\\|serialData\\|serialField"
+; 	     "\\|since\\|throws"
+; 	     "\\|version"
+; 	     "\\)\\>")
+;      '(1 font-lock-constant-face prepend))
+;     '("@\\(param\\)\\>[ \t]*\\(\\sw+\\)?"
+;       (1 font-lock-constant-face prepend)
+;       (2 font-lock-variable-name-face prepend t))
+;     '("@\\(exception\\|throws\\)\\>[ \t]*\\(\\S-+\\)?"
+;       (1 font-lock-constant-face prepend)
+;       (2 font-lock-type-face prepend t))
+;     )))
+
+;  (setq java-font-lock-keywords-3
+;   (append java-font-lock-keywords-2
+;    ;;
+;    ;; More complicated regexps for more complete highlighting for types.
+;    ;; We still have to fontify type specifiers individually, as Java is hairy.
+;    (list
+;     ;;
+;     ;; Fontify random types immediately followed by an item or items.
+;     `(eval .
+;       (list (concat "\\<\\(" ,java-type-names "\\)\\>"
+; 		    "\\([ \t]*\\[[ \t]*\\]\\)*"
+; 		    "\\([ \t]*\\sw\\)")
+; 	    ;; Fontify each declaration item.
+; 	    (list 'font-lock-match-c-style-declaration-item-and-skip-to-next
+; 		  ;; Start and finish with point after the type specifier.
+; 		  (list 'goto-char (list 'match-beginning
+; 					 (+ ,java-type-names-depth 3)))
+; 		  (list 'goto-char (list 'match-beginning
+; 					 (+ ,java-type-names-depth 3)))
+; 		  ;; Fontify as a variable or function name.
+; 		  '(1 (if (match-beginning 2)
+; 			  font-lock-function-name-face
+; 			font-lock-variable-name-face)))))
+;     ;;
+;     ;; Fontify those that are eventually followed by an item or items.
+;     (list (concat "\\<\\(" java-type-specs "\\)\\>"
+; 		  "\\([ \t]+\\sw+\\>"
+; 		  "\\([ \t]*\\[[ \t]*\\]\\)*"
+; 		  "\\)*")
+; 	  ;; Fontify each declaration item.
+; 	  '(font-lock-match-c-style-declaration-item-and-skip-to-next
+; 	    ;; Start with point after all type specifiers.
+; 	    (goto-char (or (match-beginning 5) (match-end 1)))
+; 	    ;; Finish with point after first type specifier.
+; 	    (goto-char (match-end 1))
+; 	    ;; Fontify as a variable or function name.
+; 	    (1 (if (match-beginning 2)
+; 		   font-lock-function-name-face
+; 		 font-lock-variable-name-face))))
+;     )))
+;  )
+
+; (defvar java-font-lock-keywords java-font-lock-keywords-1
+;   "Default expressions to highlight in Java mode.
+; See also `java-font-lock-extra-types'.")
+
+
+;; BEGIN SYNCHED WITH FSF 21.2.
+
+(put 'c-mode 'font-lock-defaults 
+     '((c-font-lock-keywords c-font-lock-keywords-1
+        c-font-lock-keywords-2 c-font-lock-keywords-3)
+       nil nil ((?_ . "w")) beginning-of-defun
+       (font-lock-mark-block-function . mark-defun)))
+(put 'c++-c-mode 'font-lock-defaults 'c-mode)
+(put 'elec-c-mode 'font-lock-defaults 'c-mode)
+
+(put 'c++-mode 'font-lock-defaults
+     '((c++-font-lock-keywords c++-font-lock-keywords-1
+        c++-font-lock-keywords-2 c++-font-lock-keywords-3)
+;FSF   nil nil ((?_ . "w")) beginning-of-defun
+       nil nil (("_~" . "w")) beginning-of-defun
+       (font-lock-mark-block-function . mark-defun)))
+
+(put 'obj-c-mode 'font-lock-defaults
+     '((objc-font-lock-keywords objc-font-lock-keywords-1
+        objc-font-lock-keywords-2 objc-font-lock-keywords-3)
+       nil nil ((?_ . "w") (?$ . "w")) nil
+       (font-lock-mark-block-function . mark-defun)))
+
+(put 'java-mode 'font-lock-defaults 
+     '((java-font-lock-keywords java-font-lock-keywords-1
+        java-font-lock-keywords-2 java-font-lock-keywords-3)
+       nil nil ((?_ . "w") (?$ . "w")) nil
+       (font-lock-mark-block-function . mark-defun)))
+
+;; END SYNCHED WITH FSF 21.2.
+
+
+;; TeX
+
+(put 'tex-mode 'font-lock-defaults
+     ;; For TeX modes we could use `backward-paragraph' for the same reason.
+     '(tex-font-lock-keywords nil nil ((?$ . "\""))))
+;; the nine billion names of TeX mode...
+(put 'bibtex-mode	'font-lock-defaults 'tex-mode)
+(put 'plain-tex-mode	'font-lock-defaults 'tex-mode)
+(put 'slitex-tex-mode	'font-lock-defaults 'tex-mode)
+(put 'SliTeX-mode	'font-lock-defaults 'tex-mode)
+(put 'slitex-mode	'font-lock-defaults 'tex-mode)
+(put 'latex-tex-mode	'font-lock-defaults 'tex-mode)
+(put 'LaTex-tex-mode	'font-lock-defaults 'tex-mode)
+(put 'latex-mode        'font-lock-defaults 'tex-mode)
+(put 'LaTeX-mode        'font-lock-defaults 'tex-mode)
+(put 'japanese-LaTeX-mode 'font-lock-defaults 'tex-mode)
+(put 'japanese-SliTeX-mode 'font-lock-defaults 'tex-mode)
+(put 'FoilTeX-mode	'font-lock-defaults 'tex-mode)
+(put 'LATeX-MoDe	'font-lock-defaults 'tex-mode)
+(put 'lATEx-mODe	'font-lock-defaults 'tex-mode)
+;; ok, this is getting a bit silly ...
+(put 'eDOm-xETAl	'font-lock-defaults 'tex-mode)
 
 (defvar tex-font-lock-keywords
 ;  ;; Regexps updated with help from Ulrik Dickow <dickow@nbi.dk>.
@@ -2855,6 +4483,9 @@
      3 (if (match-beginning 2) 'bold 'italic) keep))
   "Default expressions to highlight in TeX modes.")
 
+
+;; Shell modes.
+
 (defconst ksh-font-lock-keywords 
   (list
    '("\\(^\\|[^\$\\\]\\)#.*" . font-lock-comment-face)
@@ -2874,15 +4505,12 @@
   "Additional expressions to highlight in sh-mode.")
 
 
-;; Install ourselves:
-
-(add-hook 'find-file-hooks 'font-lock-set-defaults t)
-
-;;;###autoload
-(add-minor-mode 'font-lock-mode 'font-lock-mode-line-string)
-
 ;; Provide ourselves:
 
 (provide 'font-lock)
+
+;; FSF 21.2:
+;(when (eq font-lock-support-mode 'jit-lock-mode)
+;  (require 'jit-lock))
 
 ;;; font-lock.el ends here
